package hk.quantr.fs.Dialogs;

import hk.quantr.fs.Global;
import hk.quantr.fs.PExceptionDialog;
import hk.quantr.fs.PFSPanels.DIBPanel;
import hk.quantr.fs.PFSPanels.DIRPanel;
import hk.quantr.fs.PFSPanels.FABPanel;
import hk.quantr.fs.PFSPanels.FIBPanel;
import hk.quantr.fs.PFSPanels.FILEContentPanel;
import hk.quantr.fs.PFSPanels.FILEPanel;
import hk.quantr.fs.PFSPanels.SBPanel;
import hk.quantr.peterswing.CommonLib;
import javax.swing.JDialog;
import javax.swing.JFrame;

/**
 *
 * @author Peter <peter@quantr.hk>
 */
public class BlockDialog extends javax.swing.JDialog {

	byte data[];
	int blockNo;

	/**
	 * Creates new form BlockDialog2
	 */

	public BlockDialog(JFrame owner, String blockNo, byte data[]) {
		super(owner, "Block Number : " + blockNo, true);
		initComponents();
		try {
			this.blockNo = Integer.parseInt(blockNo);
			initData(data);
		} catch (Exception ex) {
			ex.printStackTrace();
			if (Global.GUI) {
				new PExceptionDialog(ex, Global.sessionNumber).setVisible(true);
			}
		}
		setSize(600,600);
		CommonLib.centerDialog(this);
	}

	public BlockDialog(JDialog owner, String blockNo, byte data[]) {
		super(owner, "Block Number : " + blockNo, true);
		initComponents();
		try {
			this.blockNo = Integer.parseInt(blockNo);
			initData(data);
		} catch (Exception ex) {
			ex.printStackTrace();
			if (Global.GUI) {
				new PExceptionDialog(ex, Global.sessionNumber).setVisible(true);
			}
		}
		setSize(600,600);
		CommonLib.centerDialog(this);
	}

	private void initData(byte data[]) {
		try {
			this.data = data;
			if (data[0] == 'S' && data[1] == 'B') {
				jTabbedPane1.add(new BlockDialogPanel2(this, new SBPanel(this, data), blockNo), "SB");
			} else if (data[0] == 'D' && data[1] == 'I' && data[2] == 'R') {
				jTabbedPane1.add(new BlockDialogPanel2(this, new DIRPanel(this, data), blockNo), "Dir");
			} else if (data[0] == 'F' && data[1] == 'A' && data[2] == 'B') {
				jTabbedPane1.add(new BlockDialogPanel2(this, new FABPanel(data), blockNo), "FAB");
			} else if (data[0] == 'D' && data[1] == 'I' && data[2] == 'B') {
				jTabbedPane1.add(new BlockDialogPanel2(this, new DIBPanel(this, data), blockNo), "DIB");
			} else if (data[0] == 'F' && data[1] == 'I' && data[2] == 'L' && data[3] == 'E') {
				jTabbedPane1.add(new BlockDialogPanel2(this, new FILEPanel(this, data), blockNo), "File");
			} else if (data[0] == 'F' && data[1] == 'I' && data[2] == 'B') {
				jTabbedPane1.add(new BlockDialogPanel2(this, new FIBPanel(this, data), blockNo), "FIB");
			} else {
				jTabbedPane1.add(new BlockDialogPanel2(this, new FILEContentPanel(data), blockNo), "Data");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			if (Global.GUI) {
				new PExceptionDialog(ex, Global.sessionNumber).setVisible(true);
			}
		}
	}

	/**
	 * This method is called from within the constructor to initialize the form. WARNING: Do NOT modify this code. The content of this method is always regenerated by the Form Editor.
	 */
	@SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jTabbedPane1 = new javax.swing.JTabbedPane();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        getContentPane().add(jTabbedPane1, java.awt.BorderLayout.CENTER);

        pack();
    }// </editor-fold>//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    public javax.swing.JTabbedPane jTabbedPane1;
    // End of variables declaration//GEN-END:variables
}
